module axi_memiface_32
(
  input  clk,
  input  reset,
  input [32-1 : 0] data_address,
  input [32-1 : 0] data_din,
  output [32-1 : 0] data_dout,
  input  data_we,
  input  data_oe,
  output [32-1 : 0] data_length,
  output  busy,
  input  write_kick,
  input  read_kick,
  input [32-1 : 0] burst_size,
  input [32-1 : 0] axi_addr,
  input  forbid,
  output [32-1 : 0] axi_reader_ARADDR,
  output [8-1 : 0] axi_reader_ARLEN,
  output  axi_reader_ARVALID,
  input  axi_reader_ARREADY,
  output [3-1 : 0] axi_reader_ARSIZE,
  output [2-1 : 0] axi_reader_ARBURST,
  output [4-1 : 0] axi_reader_ARCACHE,
  output [3-1 : 0] axi_reader_ARPROT,
  input [32-1 : 0] axi_reader_RDATA,
  input [2-1 : 0] axi_reader_RRESP,
  input  axi_reader_RLAST,
  input  axi_reader_RVALID,
  output  axi_reader_RREADY,
  output [32-1 : 0] axi_writer_AWADDR,
  output [8-1 : 0] axi_writer_AWLEN,
  output  axi_writer_AWVALID,
  output [3-1 : 0] axi_writer_AWSIZE,
  output [2-1 : 0] axi_writer_AWBURST,
  output [4-1 : 0] axi_writer_AWCACHE,
  output [3-1 : 0] axi_writer_AWPROT,
  input  axi_writer_AWREADY,
  output [32-1 : 0] axi_writer_WDATA,
  output  axi_writer_WLAST,
  output  axi_writer_WVALID,
  input  axi_writer_WREADY,
  output [4-1 : 0] axi_writer_WSTRB,
  input [2-1 : 0] axi_writer_BRESP,
  input  axi_writer_BVALID,
  output  axi_writer_BREADY
);

  wire  clk_sig;
  wire  reset_sig;
  wire [32-1 : 0] data_address_sig;
  wire [32-1 : 0] data_din_sig;
  wire [32-1 : 0] data_dout_sig;
  wire  data_we_sig;
  wire  data_oe_sig;
  wire [32-1 : 0] data_length_sig;
  wire  busy_sig;
  wire  write_kick_sig;
  wire  read_kick_sig;
  wire [32-1 : 0] burst_size_sig;
  wire [32-1 : 0] axi_addr_sig;
  wire  forbid_sig;
  reg [32-1 : 0] axi_reader_ARADDR_sig = 0;
  reg [8-1 : 0] axi_reader_ARLEN_sig = 0;
  reg  axi_reader_ARVALID_sig = 1'b0;
  wire  axi_reader_ARREADY_sig;
  wire [3-1 : 0] axi_reader_ARSIZE_sig;
  wire [2-1 : 0] axi_reader_ARBURST_sig;
  wire [4-1 : 0] axi_reader_ARCACHE_sig;
  wire [3-1 : 0] axi_reader_ARPROT_sig;
  wire [32-1 : 0] axi_reader_RDATA_sig;
  wire [2-1 : 0] axi_reader_RRESP_sig;
  wire  axi_reader_RLAST_sig;
  wire  axi_reader_RVALID_sig;
  reg  axi_reader_RREADY_sig = 1'b0;
  reg [32-1 : 0] axi_writer_AWADDR_sig = 0;
  reg [8-1 : 0] axi_writer_AWLEN_sig = 0;
  reg  axi_writer_AWVALID_sig = 1'b0;
  wire [3-1 : 0] axi_writer_AWSIZE_sig;
  wire [2-1 : 0] axi_writer_AWBURST_sig;
  wire [4-1 : 0] axi_writer_AWCACHE_sig;
  wire [3-1 : 0] axi_writer_AWPROT_sig;
  wire  axi_writer_AWREADY_sig;
  wire [32-1 : 0] axi_writer_WDATA_sig;
  reg  axi_writer_WLAST_sig = 1'b0;
  reg  axi_writer_WVALID_sig = 1'b0;
  wire  axi_writer_WREADY_sig;
  wire [4-1 : 0] axi_writer_WSTRB_sig;
  wire [2-1 : 0] axi_writer_BRESP_sig;
  wire  axi_writer_BVALID_sig;
  reg  axi_writer_BREADY_sig = 1'b0;

  wire  BUF_clk;
  wire  BUF_reset;
  wire signed [32-1 : 0] BUF_length;
  wire signed [32-1 : 0] BUF_address;
  wire signed [32-1 : 0] BUF_din;
  wire signed [32-1 : 0] BUF_dout;
  wire  BUF_we;
  wire  BUF_oe;
  reg signed [32-1 : 0] BUF_address_b = 0;
  reg signed [32-1 : 0] BUF_din_b = 0;
  wire signed [32-1 : 0] BUF_dout_b;
  reg  BUF_we_b = 1'b0;
  reg  BUF_oe_b = 1'b0;
  reg  read_state_busy = 1'b0;
  reg  write_state_busy = 1'b0;
  wire  tmp_0001;
  wire  tmp_0002;
  reg  hdl_write_kick_d = 1'b0;
  wire  tmp_0003;
  wire  tmp_0004;
  reg  hdl_read_kick_d = 1'b0;
  wire  tmp_0005;
  wire  tmp_0006;
  wire  tmp_0007;
  wire  tmp_0008;
  localparam axi_IDLE = 32'd0;
  localparam axi_sjr_tmp_state_0000 = 32'd1;
  localparam axi_sjr_tmp_state_0001 = 32'd2;
  localparam axi_sjr_tmp_state_0002 = 32'd3;
  localparam axi_sjr_tmp_state_0003 = 32'd4;
  localparam axi_sjr_tmp_state_0004 = 32'd5;
  localparam axi_sjr_tmp_state_0005 = 32'd6;
  localparam axi_sjr_tmp_state_0006 = 32'd7;
  reg [31:0] axi = axi_IDLE;
  reg signed [32-1 : 0] axi_delay = 0;
  wire  sjr_generate_U_0009_clk;
  wire  sjr_generate_U_0009_reset;
  wire  sjr_generate_U_0009_we;
  wire [32-1 : 0] sjr_generate_U_0009_din;
  wire  sjr_generate_U_0009_re;
  wire [32-1 : 0] sjr_generate_U_0009_dout;
  wire  sjr_generate_U_0009_empty;
  wire  sjr_generate_U_0009_full;
  wire [32-1 : 0] sjr_generate_U_0009_count;
  reg  tmp_0010 = 1'b0;
  wire  tmp_0011;
  reg [32-1 : 0] tmp_0012 = 0;
  wire [32-1 : 0] tmp_0013;
  wire  tmp_0014;
  wire  tmp_0015;
  wire [32-1 : 0] tmp_0016;
  reg [32-1 : 0] tmp_0017 = 0;
  wire  tmp_0018;
  wire [32-1 : 0] tmp_0019;
  wire [32-1 : 0] tmp_0020;
  reg signed [32-1 : 0] tmp_0021 = 0;
  wire signed [32-1 : 0] tmp_0022;
  wire signed [32-1 : 0] tmp_0023;
  reg  tmp_0024 = 1'b0;
  wire  tmp_0025;
  wire  tmp_0026;
  wire [32-1 : 0] tmp_0027;
  wire [8-1 : 0] tmp_0028;
  wire  tmp_0029;
  wire signed [32-1 : 0] tmp_0030;
  wire  tmp_0031;
  wire  tmp_0032;
  wire  tmp_0033;
  wire  tmp_0034;
  wire  tmp_0035;
  wire  tmp_0036;
  wire  tmp_0037;
  wire  tmp_0038;
  wire  tmp_0039;
  wire  tmp_0040;
  wire  tmp_0041;
  wire  tmp_0042;
  wire  tmp_0043;
  wire  tmp_0044;
  wire  tmp_0045;
  wire  tmp_0046;
  wire  tmp_0047;
  wire  tmp_0048;
  wire  tmp_0049;
  wire  tmp_0050;
  wire  tmp_0051;
  wire  tmp_0052;
  wire  tmp_0053;
  wire signed [32-1 : 0] tmp_0054;
  wire  tmp_0055;
  wire  tmp_0056;
  wire  tmp_0057;
  reg signed [32-1 : 0] tmp_0058 = 0;
  reg signed [32-1 : 0] tmp_0059 = 0;
  wire [32-1 : 0] tmp_0060;
  wire [8-1 : 0] tmp_0061;
  wire  tmp_0062;
  wire  tmp_0063;
  wire signed [32-1 : 0] tmp_0064;
  wire signed [32-1 : 0] tmp_0065;
  wire signed [32-1 : 0] tmp_0066;
  wire signed [32-1 : 0] tmp_0067;
  wire  tmp_0068;


  assign clk_sig = clk;
  assign reset_sig = reset;
  assign data_address_sig = data_address;
  assign data_din_sig = data_din;
  assign data_dout = data_dout_sig;
  assign data_dout_sig = BUF_dout;

  assign data_we_sig = data_we;
  assign data_oe_sig = data_oe;
  assign data_length = data_length_sig;
  assign data_length_sig = BUF_length;

  assign busy = busy_sig;
  assign busy_sig = tmp_0002;

  assign write_kick_sig = write_kick;
  assign read_kick_sig = read_kick;
  assign burst_size_sig = burst_size;
  assign axi_addr_sig = axi_addr;
  assign forbid_sig = forbid;
  assign axi_reader_ARADDR = axi_reader_ARADDR_sig;
  always @(posedge clk) begin
    if(reset == 1'b1) begin
      axi_reader_ARADDR_sig <= 0;
    end else begin
      if (axi == axi_IDLE) begin
        axi_reader_ARADDR_sig <= axi_addr_sig;
      end
    end
  end

  assign axi_reader_ARLEN = axi_reader_ARLEN_sig;
  always @(posedge clk) begin
    if(reset == 1'b1) begin
      axi_reader_ARLEN_sig <= 0;
    end else begin
      if (axi == axi_IDLE) begin
        axi_reader_ARLEN_sig <= tmp_0061;
      end
    end
  end

  assign axi_reader_ARVALID = axi_reader_ARVALID_sig;
  always @(posedge clk) begin
    if(reset == 1'b1) begin
      axi_reader_ARVALID_sig <= 1'b0;
    end else begin
      if (axi == axi_IDLE) begin
        axi_reader_ARVALID_sig <= tmp_0008;
      end else if (axi == axi_sjr_tmp_state_0005) begin
        axi_reader_ARVALID_sig <= tmp_0062;
      end
    end
  end

  assign axi_reader_ARREADY_sig = axi_reader_ARREADY;
  assign axi_reader_ARSIZE = axi_reader_ARSIZE_sig;
  assign axi_reader_ARSIZE_sig = 3'b010;

  assign axi_reader_ARBURST = axi_reader_ARBURST_sig;
  assign axi_reader_ARBURST_sig = 2'b01;

  assign axi_reader_ARCACHE = axi_reader_ARCACHE_sig;
  assign axi_reader_ARCACHE_sig = 4'h3;

  assign axi_reader_ARPROT = axi_reader_ARPROT_sig;
  assign axi_reader_ARPROT_sig = 3'b000;

  assign axi_reader_RDATA_sig = axi_reader_RDATA;
  assign axi_reader_RRESP_sig = axi_reader_RRESP;
  assign axi_reader_RLAST_sig = axi_reader_RLAST;
  assign axi_reader_RVALID_sig = axi_reader_RVALID;
  assign axi_reader_RREADY = axi_reader_RREADY_sig;
  always @(posedge clk) begin
    if(reset == 1'b1) begin
      axi_reader_RREADY_sig <= 1'b0;
    end else begin
      if (axi == axi_IDLE) begin
        axi_reader_RREADY_sig <= 1'b1;
      end
    end
  end

  assign axi_writer_AWADDR = axi_writer_AWADDR_sig;
  always @(posedge clk) begin
    if(reset == 1'b1) begin
      axi_writer_AWADDR_sig <= 0;
    end else begin
      if (axi == axi_IDLE) begin
        axi_writer_AWADDR_sig <= axi_addr_sig;
      end
    end
  end

  assign axi_writer_AWLEN = axi_writer_AWLEN_sig;
  always @(posedge clk) begin
    if(reset == 1'b1) begin
      axi_writer_AWLEN_sig <= 0;
    end else begin
      if (axi == axi_IDLE) begin
        axi_writer_AWLEN_sig <= tmp_0028;
      end
    end
  end

  assign axi_writer_AWVALID = axi_writer_AWVALID_sig;
  always @(posedge clk) begin
    if(reset == 1'b1) begin
      axi_writer_AWVALID_sig <= 1'b0;
    end else begin
      if (axi == axi_IDLE) begin
        axi_writer_AWVALID_sig <= tmp_0004;
      end else if (axi == axi_sjr_tmp_state_0000) begin
        axi_writer_AWVALID_sig <= tmp_0029;
      end
    end
  end

  assign axi_writer_AWSIZE = axi_writer_AWSIZE_sig;
  assign axi_writer_AWSIZE_sig = 3'b010;

  assign axi_writer_AWBURST = axi_writer_AWBURST_sig;
  assign axi_writer_AWBURST_sig = 2'b01;

  assign axi_writer_AWCACHE = axi_writer_AWCACHE_sig;
  assign axi_writer_AWCACHE_sig = 4'h3;

  assign axi_writer_AWPROT = axi_writer_AWPROT_sig;
  assign axi_writer_AWPROT_sig = 3'b000;

  assign axi_writer_AWREADY_sig = axi_writer_AWREADY;
  assign axi_writer_WDATA = axi_writer_WDATA_sig;
  assign axi_writer_WDATA_sig = tmp_0013;

  assign axi_writer_WLAST = axi_writer_WLAST_sig;
  always @(posedge clk) begin
    if(reset == 1'b1) begin
      axi_writer_WLAST_sig <= 1'b0;
    end else begin
      if (axi == axi_IDLE) begin
        axi_writer_WLAST_sig <= 1'b0;
      end else if (axi == axi_sjr_tmp_state_0003) begin
        axi_writer_WLAST_sig <= tmp_0044;
      end else if (axi == axi_sjr_tmp_state_0004) begin
        axi_writer_WLAST_sig <= 1'b0;
      end
    end
  end

  assign axi_writer_WVALID = axi_writer_WVALID_sig;
  always @(posedge clk) begin
    if(reset == 1'b1) begin
      axi_writer_WVALID_sig <= 1'b0;
    end else begin
      if (axi == axi_IDLE) begin
        axi_writer_WVALID_sig <= 1'b0;
      end else if (axi == axi_sjr_tmp_state_0003) begin
        axi_writer_WVALID_sig <= tmp_0050;
      end else if (axi == axi_sjr_tmp_state_0004) begin
        axi_writer_WVALID_sig <= 1'b0;
      end
    end
  end

  assign axi_writer_WREADY_sig = axi_writer_WREADY;
  assign axi_writer_WSTRB = axi_writer_WSTRB_sig;
  assign axi_writer_WSTRB_sig = 4'hf;

  assign axi_writer_BRESP_sig = axi_writer_BRESP;
  assign axi_writer_BVALID_sig = axi_writer_BVALID;
  assign axi_writer_BREADY = axi_writer_BREADY_sig;
  always @(posedge clk) begin
    if(reset == 1'b1) begin
      axi_writer_BREADY_sig <= 1'b0;
    end else begin
      if (axi == axi_IDLE) begin
        axi_writer_BREADY_sig <= 1'b1;
      end
    end
  end


  assign tmp_0001 = write_state_busy | read_state_busy;
  assign tmp_0002 = tmp_0001 | forbid_sig;
  assign tmp_0003 = ~hdl_write_kick_d;
  assign tmp_0004 = write_kick_sig & tmp_0003;
  assign tmp_0005 = ~tmp_0004;
  assign tmp_0006 = ~hdl_read_kick_d;
  assign tmp_0007 = read_kick_sig & tmp_0006;
  assign tmp_0008 = tmp_0005 & tmp_0007;
  assign tmp_0018 = tmp_0017 == 0 ? 1'b1 : 1'b0;
  assign tmp_0019 = tmp_0017 - 1;
  assign tmp_0020 = tmp_0018 == 1'b1 ? 0 : tmp_0019;
  assign tmp_0022 = BUF_address_b + 1;
  assign tmp_0023 = tmp_0021 - 1;
  assign tmp_0025 = tmp_0024 & axi_writer_WVALID_sig;
  assign tmp_0026 = tmp_0025 & axi_writer_WREADY_sig;
  assign tmp_0027 = burst_size_sig - 1;
  assign tmp_0028 = tmp_0027[32 - 32'sh00000018 - 1 : 0];
  assign tmp_0029 = ~axi_writer_AWREADY_sig;
  assign tmp_0030 = axi_writer_AWREADY_sig == 1'b1 ? tmp_0022 : BUF_address_b;
  assign tmp_0031 = tmp_0017 > 0 ? 1'b1 : 1'b0;
  assign tmp_0032 = tmp_0031 == 1'b1 ? 1'b1 : 1'b0;
  assign tmp_0033 = tmp_0017 > 0 ? 1'b1 : 1'b0;
  assign tmp_0034 = tmp_0033 == 1'b1 ? 1'b1 : 1'b0;
  assign tmp_0035 = tmp_0017 > 0 ? 1'b1 : 1'b0;
  assign tmp_0036 = tmp_0035 == 1'b1 ? 1'b1 : 1'b0;
  assign tmp_0037 = tmp_0021 == 1 ? 1'b1 : 1'b0;
  assign tmp_0038 = axi_writer_WVALID_sig & axi_writer_WREADY_sig;
  assign tmp_0039 = tmp_0038 == 1'b1 ? 1'b0 : 1'b1;
  assign tmp_0040 = tmp_0021 == 2 ? 1'b1 : 1'b0;
  assign tmp_0041 = axi_writer_WVALID_sig & axi_writer_WREADY_sig;
  assign tmp_0042 = tmp_0041 == 1'b1 ? 1'b1 : 1'b0;
  assign tmp_0043 = tmp_0040 == 1'b1 ? tmp_0042 : 1'b0;
  assign tmp_0044 = tmp_0037 == 1'b1 ? tmp_0039 : tmp_0043;
  assign tmp_0045 = tmp_0021 > 1 ? 1'b1 : 1'b0;
  assign tmp_0046 = tmp_0021 == 1 ? 1'b1 : 1'b0;
  assign tmp_0047 = axi_writer_WVALID_sig & axi_writer_WREADY_sig;
  assign tmp_0048 = tmp_0046 & tmp_0047;
  assign tmp_0049 = tmp_0048 == 1'b1 ? 1'b0 : 1'b1;
  assign tmp_0050 = tmp_0045 == 1'b1 ? 1'b1 : tmp_0049;
  assign tmp_0051 = axi_writer_WVALID_sig & axi_writer_WREADY_sig;
  assign tmp_0052 = tmp_0021 > 0 ? 1'b1 : 1'b0;
  assign tmp_0053 = tmp_0051 & tmp_0052;
  assign tmp_0054 = tmp_0053 == 1'b1 ? tmp_0023 : tmp_0021;
  assign tmp_0055 = tmp_0021 == 1 ? 1'b1 : 1'b0;
  assign tmp_0056 = axi_writer_WVALID_sig & axi_writer_WREADY_sig;
  assign tmp_0057 = tmp_0055 & tmp_0056;
  assign tmp_0060 = burst_size_sig - 1;
  assign tmp_0061 = tmp_0060[32 - 32'sh00000018 - 1 : 0];
  assign tmp_0062 = ~axi_reader_ARREADY_sig;
  assign tmp_0063 = tmp_0058 == 1 ? 1'b1 : 1'b0;
  assign tmp_0064 = tmp_0058 - 1;
  assign tmp_0065 = tmp_0059 + 1;
  assign tmp_0066 = axi_reader_RVALID_sig == 1'b1 ? tmp_0064 : tmp_0058;
  assign tmp_0067 = axi_reader_RVALID_sig == 1'b1 ? tmp_0065 : tmp_0059;
  assign tmp_0068 = axi_reader_RVALID_sig & tmp_0063;

  always @(posedge clk) begin
    if(reset == 1'b1) begin
      axi <= axi_IDLE;
      axi_delay <= 32'h0;
    end else begin
      case (axi)
        axi_IDLE : begin
          if (tmp_0004 == 1'b1) begin
            axi <= axi_sjr_tmp_state_0000;
          end else if (tmp_0008 == 1'b1) begin
            axi <= axi_sjr_tmp_state_0005;
          end
        end
        axi_sjr_tmp_state_0000 : begin
          if (axi_writer_AWREADY_sig == 1'b1) begin
            axi <= axi_sjr_tmp_state_0001;
          end
        end
        axi_sjr_tmp_state_0001 : begin
          axi <= axi_sjr_tmp_state_0002;
        end
        axi_sjr_tmp_state_0002 : begin
          axi <= axi_sjr_tmp_state_0003;
        end
        axi_sjr_tmp_state_0003 : begin
          if (tmp_0057 == 1'b1) begin
            axi <= axi_sjr_tmp_state_0004;
          end
        end
        axi_sjr_tmp_state_0004 : begin
          if (axi_writer_BVALID_sig == 1'b1) begin
            axi <= axi_IDLE;
          end
        end
        axi_sjr_tmp_state_0005 : begin
          if (axi_reader_ARREADY_sig == 1'b1) begin
            axi <= axi_sjr_tmp_state_0006;
          end
        end
        axi_sjr_tmp_state_0006 : begin
          if (tmp_0068 == 1'b1) begin
            axi <= axi_IDLE;
          end
        end
      endcase
      hdl_write_kick_d <= write_kick_sig;
      hdl_read_kick_d <= read_kick_sig;
    end
  end


  assign BUF_clk = clk_sig;

  assign BUF_reset = reset_sig;

  assign BUF_address = data_address_sig;

  assign BUF_din = data_din_sig;

  assign BUF_we = data_we_sig;

  assign BUF_oe = data_oe_sig;

  always @(posedge clk) begin
    if(reset == 1'b1) begin
      BUF_address_b <= 0;
    end else begin
      if (axi == axi_sjr_tmp_state_0000) begin
        BUF_address_b <= tmp_0030;
      end else if (axi == axi_sjr_tmp_state_0001) begin
        BUF_address_b <= tmp_0022;
      end else if (axi == axi_sjr_tmp_state_0002) begin
        BUF_address_b <= tmp_0022;
      end else if (axi == axi_sjr_tmp_state_0003) begin
        BUF_address_b <= tmp_0022;
      end else if (axi == axi_IDLE) begin
        BUF_address_b <= 0;
      end else if (axi == axi_sjr_tmp_state_0006) begin
        BUF_address_b <= tmp_0059;
      end
    end
  end

  always @(posedge clk) begin
    if(reset == 1'b1) begin
      BUF_din_b <= 0;
    end else begin
      if (axi == axi_sjr_tmp_state_0006) begin
        BUF_din_b <= axi_reader_RDATA_sig;
      end
    end
  end

  always @(posedge clk) begin
    if(reset == 1'b1) begin
      BUF_we_b <= 1'b0;
    end else begin
      if (axi == axi_sjr_tmp_state_0006) begin
        BUF_we_b <= axi_reader_RVALID_sig;
      end else begin
        BUF_we_b <= 1'b0;
      end
    end
  end

  always @(posedge clk) begin
    if(reset == 1'b1) begin
      BUF_oe_b <= 1'b0;
    end else begin
      if (axi == axi_IDLE) begin
        BUF_oe_b <= tmp_0004;
      end
    end
  end

  always @(posedge clk) begin
    if(reset == 1'b1) begin
      read_state_busy <= 1'b0;
    end else begin
      if (axi == axi_IDLE) begin
        read_state_busy <= tmp_0008;
      end
    end
  end

  always @(posedge clk) begin
    if(reset == 1'b1) begin
      write_state_busy <= 1'b0;
    end else begin
      if (axi == axi_IDLE) begin
        write_state_busy <= tmp_0004;
      end
    end
  end

  assign sjr_generate_U_0009_clk = clk_sig;

  assign sjr_generate_U_0009_reset = reset_sig;

  assign sjr_generate_U_0009_we = tmp_0010;

  assign sjr_generate_U_0009_din = tmp_0012;

  assign sjr_generate_U_0009_re = tmp_0011;

  always @(posedge clk) begin
    if(reset == 1'b1) begin
      tmp_0010 <= 1'b0;
    end else begin
      if (axi == axi_sjr_tmp_state_0001) begin
        tmp_0010 <= tmp_0032;
      end else if (axi == axi_sjr_tmp_state_0002) begin
        tmp_0010 <= tmp_0034;
      end else if (axi == axi_sjr_tmp_state_0003) begin
        tmp_0010 <= tmp_0036;
      end else begin
        tmp_0010 <= 1'b0;
      end
    end
  end

  assign tmp_0011 = tmp_0026;

  always @(posedge clk) begin
    if(reset == 1'b1) begin
      tmp_0012 <= 0;
    end else begin
      if (axi == axi_sjr_tmp_state_0001) begin
        tmp_0012 <= BUF_dout_b;
      end else if (axi == axi_sjr_tmp_state_0002) begin
        tmp_0012 <= BUF_dout_b;
      end else if (axi == axi_sjr_tmp_state_0003) begin
        tmp_0012 <= BUF_dout_b;
      end
    end
  end

  assign tmp_0013 = sjr_generate_U_0009_dout;

  assign tmp_0014 = sjr_generate_U_0009_empty;

  assign tmp_0015 = sjr_generate_U_0009_empty;

  assign tmp_0016 = sjr_generate_U_0009_count;

  always @(posedge clk) begin
    if(reset == 1'b1) begin
      tmp_0017 <= 0;
    end else begin
      if (axi == axi_IDLE) begin
        tmp_0017 <= burst_size_sig;
      end else if (axi == axi_sjr_tmp_state_0001) begin
        tmp_0017 <= tmp_0020;
      end else if (axi == axi_sjr_tmp_state_0002) begin
        tmp_0017 <= tmp_0020;
      end else if (axi == axi_sjr_tmp_state_0003) begin
        tmp_0017 <= tmp_0020;
      end
    end
  end

  always @(posedge clk) begin
    if(reset == 1'b1) begin
      tmp_0021 <= 0;
    end else begin
      if (axi == axi_IDLE) begin
        tmp_0021 <= burst_size_sig;
      end else if (axi == axi_sjr_tmp_state_0003) begin
        tmp_0021 <= tmp_0054;
      end
    end
  end

  always @(posedge clk) begin
    if(reset == 1'b1) begin
      tmp_0024 <= 1'b0;
    end else begin
      if (axi == axi_sjr_tmp_state_0003) begin
        tmp_0024 <= 1'b1;
      end else begin
        tmp_0024 <= 1'b0;
      end
    end
  end

  always @(posedge clk) begin
    if(reset == 1'b1) begin
      tmp_0058 <= 0;
    end else begin
      if (axi == axi_IDLE) begin
        tmp_0058 <= burst_size_sig;
      end else if (axi == axi_sjr_tmp_state_0006) begin
        tmp_0058 <= tmp_0066;
      end
    end
  end

  always @(posedge clk) begin
    if(reset == 1'b1) begin
      tmp_0059 <= 0;
    end else begin
      if (axi == axi_IDLE) begin
        tmp_0059 <= 0;
      end else if (axi == axi_sjr_tmp_state_0006) begin
        tmp_0059 <= tmp_0067;
      end
    end
  end


  dualportram
  #(
    .WIDTH(32),
    .DEPTH(10),
    .WORDS(1024)
  )
  BUF
  (
    .clk(clk),
    .reset(reset),
    .length(BUF_length),
    .address(BUF_address),
    .din(BUF_din),
    .dout(BUF_dout),
    .we(BUF_we),
    .oe(BUF_oe),
    .address_b(BUF_address_b),
    .din_b(BUF_din_b),
    .dout_b(BUF_dout_b),
    .we_b(BUF_we_b),
    .oe_b(BUF_oe_b)
  );

  simple_fifo_32
  sjr_generate_U_0009
  (
    .clk(clk),
    .reset(reset),
    .we(sjr_generate_U_0009_we),
    .din(sjr_generate_U_0009_din),
    .re(sjr_generate_U_0009_re),
    .dout(sjr_generate_U_0009_dout),
    .empty(sjr_generate_U_0009_empty),
    .full(sjr_generate_U_0009_full),
    .count(sjr_generate_U_0009_count)
  );


endmodule
